from twilio.base import values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.api.v2010.account.available_phone_number.local import LocalList as LocalList
from twilio.rest.api.v2010.account.available_phone_number.machine_to_machine import MachineToMachineList as MachineToMachineList
from twilio.rest.api.v2010.account.available_phone_number.mobile import MobileList as MobileList
from twilio.rest.api.v2010.account.available_phone_number.national import NationalList as NationalList
from twilio.rest.api.v2010.account.available_phone_number.shared_cost import SharedCostList as SharedCostList
from twilio.rest.api.v2010.account.available_phone_number.toll_free import TollFreeList as TollFreeList
from twilio.rest.api.v2010.account.available_phone_number.voip import VoipList as VoipList
from typing import Any, Optional

class AvailablePhoneNumberCountryList(ListResource):
    def __init__(self, version: Any, account_sid: Any) -> None: ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def get(self, country_code: Any): ...
    def __call__(self, country_code: Any): ...

class AvailablePhoneNumberCountryPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class AvailablePhoneNumberCountryContext(InstanceContext):
    def __init__(self, version: Any, account_sid: Any, country_code: Any) -> None: ...
    def fetch(self): ...
    @property
    def local(self): ...
    @property
    def toll_free(self): ...
    @property
    def mobile(self): ...
    @property
    def national(self): ...
    @property
    def voip(self): ...
    @property
    def shared_cost(self): ...
    @property
    def machine_to_machine(self): ...

class AvailablePhoneNumberCountryInstance(InstanceResource):
    def __init__(self, version: Any, payload: Any, account_sid: Any, country_code: Optional[Any] = ...) -> None: ...
    @property
    def country_code(self): ...
    @property
    def country(self): ...
    @property
    def uri(self): ...
    @property
    def beta(self): ...
    @property
    def subresource_uris(self): ...
    def fetch(self): ...
    @property
    def local(self): ...
    @property
    def toll_free(self): ...
    @property
    def mobile(self): ...
    @property
    def national(self): ...
    @property
    def voip(self): ...
    @property
    def shared_cost(self): ...
    @property
    def machine_to_machine(self): ...
