from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class WebChannelList(ListResource):
    def __init__(self, version: Any) -> None: ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def create(self, flex_flow_sid: Any, identity: Any, customer_friendly_name: Any, chat_friendly_name: Any, chat_unique_name: Any = ..., pre_engagement_data: Any = ...): ...
    def get(self, sid: Any): ...
    def __call__(self, sid: Any): ...

class WebChannelPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class WebChannelContext(InstanceContext):
    def __init__(self, version: Any, sid: Any) -> None: ...
    def fetch(self): ...
    def update(self, chat_status: Any = ..., post_engagement_data: Any = ...): ...
    def delete(self): ...

class WebChannelInstance(InstanceResource):
    class ChatStatus:
        INACTIVE: str = ...
    def __init__(self, version: Any, payload: Any, sid: Optional[Any] = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def flex_flow_sid(self): ...
    @property
    def sid(self): ...
    @property
    def url(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    def fetch(self): ...
    def update(self, chat_status: Any = ..., post_engagement_data: Any = ...): ...
    def delete(self): ...
